////////////////
#define ARCH_IS_LITTLE_ENDIAN

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <fat.h>


#include <xvid.h>

//pGnX,Nѥh 
//#define SPEED_TEST

//uΩpc 
//#define BUFFER_SIZE (2*1024*1024)  

//iTndsWB@,O_ǪbufferѼ, 
#define BUFFER_SIZE (2*128*128) 

static int XDIM = 0;
static int YDIM = 0;

static void *dec_handle = NULL;



static const int display_buffer_bytes = 0;

#define MIN_USEFUL_BYTES 1

static int dec_init(int use_assembler, int debug_level);
static int dec_main(unsigned char *istream,
					unsigned char *ostream,
					int istream_size,
					xvid_dec_stats_t *xvid_dec_stats);
//static int dec_stop();
static int write_image(char *prefix, unsigned char *image);
static int write_tga(char *filename, unsigned char *image);

/////////////////////
#include "main.h"

// Function: main()
int main(int argc, char ** argv)
{
	PA_Init();    // Initializes PA_Lib
	PA_InitVBL(); // Initializes a standard VBL
   fatInitDefault();
   PA_Init16bitBg(1,0);
////////////////////////////////////////////////////////////////
	unsigned char *mp4_buffer = NULL;
	unsigned char *mp4_ptr    = NULL;
	unsigned char *out_buffer = NULL;
	int useful_bytes;
	int chunk;
	xvid_dec_stats_t xvid_dec_stats;
	
//	double totaldectime;
  
	long totalsize;
	int status;

	char filename[256];
  
	FILE *in_file;
	int filenr;
	//int i;

  //PA_InitText(1,2);

	in_file = fopen("s.m4v", "rb");

  //PA_OutputSimpleText(1,1,1,"decoding mepg4 video ...!");

	mp4_buffer = (unsigned char *) malloc(BUFFER_SIZE);
	mp4_ptr = mp4_buffer;
	if (!mp4_buffer)
		goto free_all_memory;	

	status = dec_init(0,0);

	useful_bytes = fread(mp4_buffer, 1, BUFFER_SIZE, in_file);

	totalsize = 0;
	filenr = 0;
	mp4_ptr = mp4_buffer;
	chunk = 0;
	
	do {
		int used_bytes = 0;

		if (mp4_ptr > mp4_buffer + BUFFER_SIZE/2) {
			int already_in_buffer = (mp4_buffer + BUFFER_SIZE - mp4_ptr);

			if (already_in_buffer > 0)
				memcpy(mp4_buffer, mp4_ptr, already_in_buffer);

			mp4_ptr = mp4_buffer; 

            if(!feof(in_file)) {

				useful_bytes += fread(mp4_buffer + already_in_buffer,
									  1, BUFFER_SIZE - already_in_buffer,
									  in_file);
			}
		}


		do {


			used_bytes = dec_main(mp4_ptr, out_buffer, useful_bytes, &xvid_dec_stats);

			if(xvid_dec_stats.type == XVID_TYPE_VOL) {

				if(XDIM*YDIM < xvid_dec_stats.data.vol.width*xvid_dec_stats.data.vol.height) {

					XDIM = xvid_dec_stats.data.vol.width;
					YDIM = xvid_dec_stats.data.vol.height;

					if(out_buffer) free(out_buffer);

					out_buffer = (unsigned char*)malloc(XDIM*YDIM*4);
					if(out_buffer == NULL)
						goto free_all_memory;

				}

			}

			if(used_bytes > 0) {
				mp4_ptr += used_bytes;
				useful_bytes -= used_bytes;

				totalsize += used_bytes;
			}

		} while (xvid_dec_stats.type <= 0 && useful_bytes > MIN_USEFUL_BYTES);

        if(useful_bytes < 0)
            break;

      #ifndef SPEED_TEST
		sprintf(filename, "%sdec%05d","", filenr);
      write_image(filename, out_buffer);
      #endif

		filenr++;

	} while (useful_bytes>MIN_USEFUL_BYTES || !feof(in_file));

	useful_bytes = 0; 


	do {

		int used_bytes;

        do {
             used_bytes = dec_main(NULL, out_buffer, -1, &xvid_dec_stats);
        } while(used_bytes>=0 && xvid_dec_stats.type <= 0);

        if (used_bytes < 0) {   /* XVID_ERR_END */
            break;
        }

      #ifndef SPEED_TEST
		sprintf(filename, "%sdec%05d","", filenr);
      write_image(filename, out_buffer);
       #endif

		filenr++;

	}while(1);
	


 /*release_all:
  	if (dec_handle) {
	  	status = dec_stop();
	}*/

 free_all_memory:
	free(out_buffer);
	free(mp4_buffer);
////////////////////////////////////////////////////////////////
	
	//PA_OutputSimpleText(1,1,1,"decoding mepg4 done  ...!");

	
	// Infinite loop to keep the program running
	while (1)
	{
	
	
	
	
		PA_WaitForVBL();
	}
	
	return 0;
} // End of main()




static int write_image(char *prefix, unsigned char *image)
{
	char filename[1024];
	char *ext;
	int ret;


		ext = "tga";


	sprintf(filename, "%s.%s", prefix, ext);


		ret = write_tga(filename, image);


	return(ret);
}

static int write_tga(char *filename, unsigned char *image)
{
	//FILE * f;
	char hdr[18];

	//f = fopen(filename, "wb");
	/*if ( f == NULL) {
		return -1;
	}*/

	hdr[0]  = 0; /* ID length */
	hdr[1]  = 0; /* Color map type */
	hdr[2]  = 2; /* Uncompressed true color (2) or greymap (3) */
	hdr[3]  = 0; /* Color map specification (not used) */
	hdr[4]  = 0; /* Color map specification (not used) */
	hdr[5]  = 0; /* Color map specification (not used) */
	hdr[6]  = 0; /* Color map specification (not used) */
	hdr[7]  = 0; /* Color map specification (not used) */
	hdr[8]  = 0; /* LSB X origin */
	hdr[9]  = 0; /* MSB X origin */
	hdr[10] = 0; /* LSB Y origin */
	hdr[11] = 0; /* MSB Y origin */
	hdr[12] = (XDIM>>0)&0xff; /* LSB Width */
	hdr[13] = (XDIM>>8)&0xff; /* MSB Width */
	//if (BPP > 1) {
		hdr[14] = (YDIM>>0)&0xff; /* LSB Height */
		hdr[15] = (YDIM>>8)&0xff; /* MSB Height */
	//} else {
		//hdr[14] = ((YDIM*3)>>1)&0xff; /* LSB Height */
		//hdr[15] = ((YDIM*3)>>9)&0xff; /* MSB Height */
	//}
	hdr[16] = 3*8;
	hdr[17] = 0x00 | (1<<5) /* Up to down */ | (0<<4); /* Image descriptor */
	
	/* Write header */
	//fwrite(hdr, 1, sizeof(hdr), f);

#ifdef ARCH_IS_LITTLE_ENDIAN
	/* write first plane */
	//fwrite(image, 1, XDIM*YDIM*3, f);
///////////////////  to lcd

   unsigned char r,g,b;
  
  		for(unsigned int i=0 ;i<256;i++)
		for(unsigned int j=0;j<192;j++)
      {
   		r= (image[(j*256+i)*3+2]) >>3;
		   g= (image[(j*256+i)*3+1]) >>3;
			b= (image[(j*256+i)*3]) >>3;
			PA_Put16bitPixel(1,i,j,PA_RGB(r,g,b)); 
      }   

///////////////////
#else
/*	{
		int i;
		for (i=0; i<XDIM*YDIM*3;i+=3) {
				fputc(*(image+i+2), f);
				fputc(*(image+i+1), f);
				fputc(*(image+i+0), f);
		}
	}*/
#endif

	//fclose(f);

	return(0);
}


static int
dec_init(int use_assembler, int debug_level)
{
	int ret;

	xvid_gbl_init_t   xvid_gbl_init;
	xvid_dec_create_t xvid_dec_create;

	/* Reset the structure with zeros */
	memset(&xvid_gbl_init, 0, sizeof(xvid_gbl_init_t));
	memset(&xvid_dec_create, 0, sizeof(xvid_dec_create_t));

	/*------------------------------------------------------------------------
	 * XviD core initialization
	 *----------------------------------------------------------------------*/

	/* Version */
	xvid_gbl_init.version = XVID_VERSION;

	/* Assembly setting */
	if(use_assembler)
#ifdef ARCH_IS_IA64
		xvid_gbl_init.cpu_flags = XVID_CPU_FORCE | XVID_CPU_IA64;
#else
	xvid_gbl_init.cpu_flags = 0;
#endif
	else
		xvid_gbl_init.cpu_flags = XVID_CPU_FORCE;

	xvid_gbl_init.debug = debug_level;

	xvid_global(NULL, 0, &xvid_gbl_init, NULL);

	/*------------------------------------------------------------------------
	 * XviD encoder initialization
	 *----------------------------------------------------------------------*/

	/* Version */
	xvid_dec_create.version = XVID_VERSION;

	/*
	 * Image dimensions -- set to 0, xvidcore will resize when ever it is
	 * needed
	 */
	xvid_dec_create.width = 0;
	xvid_dec_create.height = 0;

	ret = xvid_decore(NULL, XVID_DEC_CREATE, &xvid_dec_create, NULL);

	dec_handle = xvid_dec_create.handle;

	return(ret);
}

/* decode one frame  */
static int
dec_main(unsigned char *istream,
		 unsigned char *ostream,
		 int istream_size,
		 xvid_dec_stats_t *xvid_dec_stats)
{

	int ret;

	xvid_dec_frame_t xvid_dec_frame;

	/* Reset all structures */
	memset(&xvid_dec_frame, 0, sizeof(xvid_dec_frame_t));
	memset(xvid_dec_stats, 0, sizeof(xvid_dec_stats_t));

	/* Set version */
	xvid_dec_frame.version = XVID_VERSION;
	xvid_dec_stats->version = XVID_VERSION;

	/* No general flags to set */
	xvid_dec_frame.general          = 0;

	/* Input stream */
	xvid_dec_frame.bitstream        = istream;
	xvid_dec_frame.length           = istream_size;

	/* Output frame structure */
	xvid_dec_frame.output.plane[0]  = ostream;
	xvid_dec_frame.output.stride[0] = XDIM*3;
	xvid_dec_frame.output.csp = XVID_CSP_BGR;//CSP;

	ret = xvid_decore(dec_handle, XVID_DEC_DECODE, &xvid_dec_frame, xvid_dec_stats);

	return(ret);
}

/* close decoder to release resources */
/*static int
dec_stop()
{
	int ret;

	ret = xvid_decore(dec_handle, XVID_DEC_DESTROY, NULL, NULL);

	return(ret);
}*/


